#ifndef READ_FUN_H
#define	READ_FUN_H

#include <sdai.h>

//print Error information for debugging purposes
extern void PrintErrorState(ErrorDescriptor &err);

// print istream error information for debugging purposes
extern void IStreamState(istream &in);

extern int 
ReadInteger(SdaiInteger &val, istream &in, ErrorDescriptor *err, 
	    char *tokenList);

extern int 
ReadInteger(SdaiInteger &val, const char *s, ErrorDescriptor *err, 
	    char *tokenList);

extern Severity 
IntValidLevel (const char *attrValue, ErrorDescriptor *err,
	       int clearError, int optional, char *tokenList);

extern int
ReadReal(SdaiReal &val, istream &in, ErrorDescriptor *err, 
	 char *tokenList);

extern int
ReadReal(SdaiReal &val, const char *s, ErrorDescriptor *err, 
	 char *tokenList);

extern Severity 
RealValidLevel (const char *attrValue, ErrorDescriptor *err,
		int clearError, int optional, char *tokenList);

extern int
ReadNumber(SdaiReal &val, istream &in, ErrorDescriptor *err, 
	   char *tokenList);

extern int
ReadNumber(SdaiReal &val, const char *s, ErrorDescriptor *err, 
	   char *tokenList);

extern Severity 
NumberValidLevel (const char *attrValue, ErrorDescriptor *err,
		  int clearError, int optional, char *tokenList);

#endif
